.586p
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc

includelib \masm32\lib\masm32.lib 
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

BackupOp PROTO :DWORD,:DWORD,:DWORD,:DWORD
WriteHookOp PROTO :DWORD,:DWORD,:DWORD

.data?
hInstance dd ?
hLib dd ?
hHook dd ?
hHookProc dd ?
hCurrentProcess dd ?
startinfo STARTUPINFO <>
pi PROCESS_INFORMATION <>

.data
kernelstr db "kernel32.dll",0
crtprcssstr db "CreateProcessA",0
testapp db ".\target.exe",0
backBuf db 20 dup(0)
writeBuf db 20 dup(0)

.code

start:

invoke GetModuleHandle, NULL
mov dword ptr [hInstance], eax
invoke GetModuleHandle,addr kernelstr
mov hLib,eax
invoke GetProcAddress,hLib,addr crtprcssstr
mov hHookProc,eax
invoke GetCurrentProcess
mov hCurrentProcess,eax
invoke BackupOp,hCurrentProcess,hHookProc,addr backBuf,20
invoke WriteHookOp,hCurrentProcess,hHookProc,addr writeBuf
nop
nop
nop
invoke GetStartupInfo,offset startinfo 
invoke CreateProcess,offset testapp,0,0,0,FALSE,NORMAL_PRIORITY_CLASS,0,0,offset startinfo,offset pi
invoke ExitProcess, 0


;backup the executable data to pBuf from startAddress to startAddress+nBackLen
BackupOp proc hProcess:DWORD,startAddress:DWORD,pBuf:DWORD,nBackLen:DWORD
local backed:DWORD
invoke ReadProcessMemory,hProcess,startAddress,pBuf,nBackLen,addr backed
ret
BackupOp endp

;restore the data
RestoreOp proc hProcess:DWORD,startAddress:DWORD,pBuf:DWORD,nLen:DWORD
local w:DWORD,tmp:DWORD
invoke VirtualProtectEx,hProcess,startAddress,nLen,PAGE_READWRITE,addr tmp
invoke WriteProcessMemory,hProcess,startAddress,pBuf,nLen,addr w
invoke VirtualProtectEx,hProcess,startAddress,nLen,tmp,addr tmp
ret
RestoreOp endp


;Write "mov eax,HookedCreatProcess" and "jmp eax" at startAddress(CreateProcessA) so when the process call CreateProcessA,it will jump to call HookedCreateProcess.
WriteHookOp proc uses esi edi ebx hProcess:DWORD,startAddress:DWORD,pBuf:DWORD
local w:DWORD
LOCAL tmp:DWORD
jmp @F
opstart:
mov eax,HookedCreateProcess
jmp eax
opend:
@@:
lea ebx,[opend]
lea edi,[opstart]
sub ebx,edi
mov edi,pBuf
lea esi,[opstart]
mov ecx,ebx
rep movsb
invoke VirtualProtectEx,hProcess,startAddress,ebx,PAGE_READWRITE,addr tmp
invoke WriteProcessMemory,hProcess,startAddress,pBuf,ebx,addr w
invoke VirtualProtectEx,hProcess,startAddress,ebx,tmp,addr tmp
ret
WriteHookOp endp


HookedCreateProcess proc lpAppName:DWORD,lpCmdLine:DWORD,lpPA:DWORD,lpPA2:DWORD,bInheritHandles:DWORD,dwCreationFlags:DWORD,lpEnv:DWORD,lpCD:DWORD,lpSti:DWORD,lpPI:DWORD
invoke MessageBeep,MB_ICONERROR
invoke RestoreOp,hCurrentProcess,hHookProc,addr backBuf,20
invoke CreateProcess,lpAppName,lpCmdLine,lpPA,lpPA2,bInheritHandles,dwCreationFlags,lpEnv,lpCD,lpSti,lpPI
push eax
invoke WriteHookOp,hCurrentProcess,hHookProc,addr writeBuf
pop eax
ret
HookedCreateProcess endp





end start
